'****************************************************************
'*  Name    : GIEDisable.inc                                    *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2017 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 30/10/2017                                        *
'*  Version : 1.1                                               *
'*  Notes   : Macros to disable/enable the GIE interrupt bit    *
'*          :                                                   *
'****************************************************************
$ifndef _GIEDisableInc
    $define _GIEDisableInc
'    GoTo _GIEDisableIncExit
'===============================================================================
' Declare a variable for the library
'    $ifndef _INTCON_Save
'    $define _INTCON_Save
'    Dim INTCON_Save As Byte System
'    $endif 
'------------------------------------------------------------------------------- 
$ifndef GIE_Disable
    $define GIE_Disable()       '
    $ifndef _INTCON_Save        '
    $define _INTCON_Save        '
    Dim INTCON_Save As Byte System '
    $endif                      '
    #ifdef __INTERRUPTS_ENABLED '
    INTCON_Save = INTCON        '
    INTCONBits_GIE = 0          '
    #endif
$endif

$ifndef GIE_Restore
    $define GIE_Restore()        '
    #ifdef __INTERRUPTS_ENABLED  '
    If INTCON_Save.7 = 1 Then    '
        INTCONBits_GIE = 1       ' 
    EndIf                        '
    #endif
$endif

$ifndef GIE_OFF
    $define GIE_OFF() INTCON.7 = 0
$endif

$ifndef GIE_ON
    $define GIE_ON() INTCON.7 = 1
$endif

'===============================================================================
_GIEDisableIncExit:
$endif

