'****************************************************************
'*  Name    : HRSOutTwoStopBits.inc                             *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2016 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 21/09/2016                                        *
'*  Version : 1.0                                               *
'*  Purpose : Send a byte via the UART with 2 stop bits         *
'*  Notes   : Bypass the compiler's HRSOut library subroutine   *
'****************************************************************
'
' Version 1.1 24/09/2016
' Using the TXIF interrupt flag too. You can choose beetwen TXIF or TMRT flags.
'
'===============================================================================
' This program is free software, you can redistribute it and/or modify.
' The code is offered as-is and the author take any responsibility for its use.
' This program is distributed in the hope that it will be useful, but WITHOUT ANY
' WARRANTY. However, a mention of the author and compiler would be appreciated.
'
' Este programa es un software libre, puede redistribuirlo y/o modificarlo.
' Se entrega este cdigo tal como esta y el autor NO se hace responsable de
' su utilizacin. Este programa se distribuye con la esperanza de que sea til,
' pero SIN NINGUNA GARANTA. No obstante citar el autor y el compilador
' sera muy apreciado.

' Ce programme est un logiciel libre, vous pouvez le redistribuer et/ou modifier.
' Ce logiciel est offert tel qu'il est, et son auteur NE prend AUCUNE responsabilit
' pour son utilization. Ce programme est distribu dans l'espoir qu'il sera util,
' mais SANS AUCUNE GARANTIE. Cependant mentionner l'auteur et le compileur serait
' trs aprci.
'-------------------------------------------------------------------------------
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
' INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
' PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHOR OR COPYRIGHT
' HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
' OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
' SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
'###############################################################################

    $ifndef _HRSOutTwoStopBitsInc_
    $define _HRSOutTwoStopBitsInc_    
'*******************************************************************************
    #ifdef __SYSCOM_HRSOUT1_REQ_
'===============================================================================
    #Disable HRSOut             ' Bypass the compiler's HRSOut library subroutine
'===============================================================================
    GoTo OverHRSOut1Exit
'-------------------------------------------------------------------------------
Asm
HRSOut
EndAsm
    #ifdef watchdog_req
    Clrwdt
    #endif 
    #ifdef __INTERRUPTS_ENABLED
    PRODH = INTCON
    INTCONBits_GIE = 0              ' Clear the GIE bit.
    #endif

    While TXSTABits_TRMT = 0 : Wend ' Waiting UART ready to transmit.
''    While PIR1Bits_TXIF = 0 : Wend ' Waiting UART ready to transmit.

    ' To avoid some old PIC's errata the bits are set after sent the last byte.
    TXSTABits_TX9 = 1               ' Nine bit mode for 2 stop bits for transmision.
    TXSTABits_TX9D = 1              ' Send the first stop bit. The second stop bit is set by the UART.
    TXREG = WREG                    ' Start sending the byte
    #ifdef __INTERRUPTS_ENABLED
    If PRODH.7 = 1 Then
        INTCONBits_GIE = 1          ' Restore the GIE interrupt condition.
    EndIf
    #endif
    Return 
'-------------------------------------------------------------------------------
    #endif  ' __SYSCOM_HRSOUT1_REQ_
'===============================================================================
$define CleanUART1()     '
    Clear RCSTABits_CREN ' 
    Set RCSTABits_CREN   ' 
    WREG = RCREG

'-------------------------------------------------------------------------------
OverHRSOut1Exit:
'*******************************************************************************
    $if _uart = 2
    #ifdef __SYSCOM_HRSOUT2_REQ_
'===============================================================================
    #Disable HRSOut2             ' Bypass the compiler's HRSOut2 library subroutine
'===============================================================================
    GoTo OverHRSOut2Exit
'-------------------------------------------------------------------------------
Asm
HRSOUT@2
EndAsm
    #ifdef watchdog_req
    Clrwdt
    #endif 
    #ifdef __INTERRUPTS_ENABLED
    PRODH = INTCON
    INTCONBits_GIE = 0                  ' Clear the GIE bit.
    #endif

    While TXSTA2Bits_TRMT = 0 : Wend    ' Waiting UART ready To transmit.
''    While PIR3Bits_TX2IF = 0 : Wend ' Waiting UART ready to transmit.

    ' To avoid some old PIC's errata the bits are set after sent the last byte.
    TXSTA2Bits_TX9 = 1                  ' Nine bit mode for 2 stop bits for transmision.
    TXSTA2Bits_TX9D = 1                 ' Send the first stop bit. The second stop bit is set by the UART.
    TXREG2 = WREG                       ' Start sending the Byte
    #ifdef __INTERRUPTS_ENABLED
    If PRODH.7 = 1 Then
        INTCONBits_GIE = 1              ' Restore the GIE interrupt condition.
    EndIf
    #endif
    Return 
'-------------------------------------------------------------------------------
    #endif  ' __SYSCOM_HRSOUT2_REQ_
'===============================================================================
$define CleanUART2()      '
    Clear RCSTA2Bits_CREN ' 
    Set RCSTA2Bits_CREN   ' 
    WREG = RCREG2

'-------------------------------------------------------------------------------
OverHRSOut2Exit:
    $endif
'===============================================================================
    $endif  ' _HRSOutTwoStopBitsInc_ 
