'****************************************************************
'*  Name    : ORG_SyncBlock.inc                                 *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2017 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 16/04/2017                                        *
'*  Version : 1.1                                               *
'*  Notes   :                                                   *
'*          :                                                   *
'****************************************************************

    $ifndef ERASE_FLASH_BLOCKSIZE
    $error "Define the ERASE_FLASH_BLOCKSIZE 64, 128, 256, 512 or 1024 before the Include file"  
    $endif

    $if ERASE_FLASH_BLOCKSIZE > 1024
        $error "ERASE_FLASH_BLOCKSIZE must be 64, 128, 256, 512 or 1024!"
    $endif
    $if ERASE_FLASH_BLOCKSIZE < 64
        $error "ERASE_FLASH_BLOCKSIZE value seems not correct, see the datatsheet!"
    $endif
'-------------------------------------------------------------------------------

$if ERASE_FLASH_BLOCKSIZE = 1024
$define MASK_ERASE_BLOCK 64512
$endif

$if ERASE_FLASH_BLOCKSIZE = 512
$define MASK_ERASE_BLOCK 65024
$endif

$if ERASE_FLASH_BLOCKSIZE = 256
$define MASK_ERASE_BLOCK 65280
$endif

$if ERASE_FLASH_BLOCKSIZE = 128
$define MASK_ERASE_BLOCK 65408
$endif

$if ERASE_FLASH_BLOCKSIZE = 64
$define MASK_ERASE_BLOCK 65472
$endif

' Syncronize with the ERASE BLOCK
$define ORG_EBlock(pAddress) Org (pAddress & MASK_ERASE_BLOCK)

'-------------------------------------------------------------------------------

